package de.uebungstool.uebungstool.scheduling.strategies;

import static de.uebungstool.uebungstool.scheduling.threads.SchedulingDiagramConstants.STRATEGIES_EDF;

import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.databind.ObjectMapper;
import de.uebungstool.uebungstool.scheduling.logic.SchedulingService;
import de.uebungstool.uebungstool.scheduling.threads.SchedulingDiagram;
import de.uebungstool.uebungstool.scheduling.threads.SchedulingUserLevelThread;
import java.util.Arrays;
import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Test;

class EDFNonPreemptiveIntegrationTest {

  /*
   * These testcases only test integration tests, because the same code is used as in SJF and FCFS which are tested more extensively.
   * The only difference ist the sorting strategy of the waiting threads.
   */
  /**
   * configuration String can be created with the client: 1. create a Configuration 2. Fill in the
   * diagram 3. Click generate 'ConfigurationString'
   *
   * <p>All values in the status field will be used to create a user input for both diagrams and it
   * will also be used as the correction values in the expected Diagram
   *
   * <p>Also save the configuration String in order to restore the configuration in browser
   */
  private SchedulingDiagram inputDiagram;

  private SchedulingDiagram expectedDiagram;

  SchedulingService schedulerService = new SchedulingService();

  /**
   * Initialises the Diagram Object with a valid EDF Strategy configuration This is the same
   * standard configuration which is used in the Website.
   */
  @BeforeEach
  public void initDiagrams() {
    expectedDiagram = initDiagram();
    inputDiagram = initDiagram();
  }

  /**
   * Creates one Diagram with the standard configuration for this strategy
   *
   * @return new diagram
   */
  private SchedulingDiagram initDiagram() {
    SchedulingDiagram diagram = new SchedulingDiagram();
    diagram.setStrategy(STRATEGIES_EDF);
    diagram.setPreemptive(false);
    diagram.setSchedulerTime(true);
    diagram.setDispatcherTime(false);
    diagram.setCoreNumber(1);
    diagram.setInitialScheduler(false);
    return diagram;
  }

  private boolean testConfiguration(String obj) throws JsonProcessingException {
    ObjectMapper objectMapper = new ObjectMapper();
    inputDiagram.userLevelThreads = objectMapper.readValue(obj, SchedulingUserLevelThread[].class);
    expectedDiagram.userLevelThreads =
        initThreadsExpectedDiagram(objectMapper.readValue(obj, SchedulingUserLevelThread[].class));

    schedulerService.evaluate(inputDiagram);
    return inputDiagram.equalCorrection(expectedDiagram);
  }

  private SchedulingUserLevelThread[] initThreadsExpectedDiagram(
      SchedulingUserLevelThread[] readValue) {
    for (SchedulingUserLevelThread u : readValue) {
      Arrays.stream(u.getCells()).forEach(c -> c.setCorrected(c.getStatus()));
    }
    return readValue;
  }

  /**
   * Configuration:
   * {"strategy":"EDF","schedulerTime":true,"dispatcherTime":true,"userSchedulerTime":true,"preemptive":false,"initialScheduler":false,"allUserLevelThreads":[{"parentid":1,"ioAftern":-1,"ioLength":-1,"deadline":18,"startTime":4,"computingTime":9,"id":1000,"name":"P1_U0","startTimePrevious":4,"deadlinePrevious":18,"IOInterruptionActivated":false,"priority":0,"deadlineBackup":18},{"parentid":1,"ioAftern":-1,"ioLength":-1,"deadline":14,"startTime":0,"computingTime":2,"id":1001,"name":"P1_U1","startTimePrevious":0,"deadlinePrevious":14,"IOInterruptionActivated":false,"priority":4,"deadlineBackup":8},{"parentid":1,"ioAftern":-1,"ioLength":-1,"deadline":21,"startTime":3,"computingTime":4,"id":1002,"name":"P1_U2","startTimePrevious":3,"deadlinePrevious":21,"IOInterruptionActivated":false,"priority":19,"deadlineBackup":12},{"parentid":1,"ioAftern":2,"ioLength":2,"deadline":25,"startTime":1,"computingTime":5,"id":1003,"name":"P1_U3","startTimePrevious":1,"deadlinePrevious":25,"IOInterruptionActivated":true,"priority":3,"deadlineBackup":13},{"parentid":2,"ioAftern":-1,"ioLength":-1,"deadline":22,"startTime":2,"computingTime":5,"id":2000,"name":"P2_U0","startTimePrevious":2,"deadlinePrevious":22,"IOInterruptionActivated":false,"priority":0,"deadlineBackup":8},{"parentid":2,"ioAftern":-1,"ioLength":-1,"deadline":33,"startTime":2,"computingTime":6,"id":2001,"name":"P2_U1","startTimePrevious":2,"deadlinePrevious":33,"IOInterruptionActivated":false,"priority":17,"deadlineBackup":11},{"parentid":2,"ioAftern":5,"ioLength":2,"deadline":36,"startTime":3,"computingTime":6,"id":2002,"name":"P2_U2","startTimePrevious":3,"deadlinePrevious":36,"IOInterruptionActivated":true,"priority":12,"deadlineBackup":9},{"parentid":2,"ioAftern":3,"ioLength":4,"deadline":20,"startTime":6,"computingTime":6,"id":2003,"name":"P2_U3","startTimePrevious":6,"deadlinePrevious":20,"IOInterruptionActivated":true,"priority":5,"deadlineBackup":12},{"parentid":3,"ioAftern":-1,"ioLength":-1,"deadline":8,"startTime":0,"computingTime":2,"id":3000,"name":"P3_U0","startTimePrevious":0,"deadlinePrevious":8,"IOInterruptionActivated":false,"priority":0,"deadlineBackup":8},{"parentid":3,"ioAftern":-1,"ioLength":-1,"deadline":15,"startTime":4,"computingTime":5,"id":3001,"name":"P3_U1","startTimePrevious":4,"deadlinePrevious":15,"IOInterruptionActivated":false,"priority":5,"deadlineBackup":15},{"parentid":-1,"ioAftern":-1,"ioLength":-1,"deadline":-1,"startTime":-1,"computingTime":-1,"id":-1,"name":"Scheduler","startTimePrevious":-1,"deadlinePrevious":-1,"IOInterruptionActivated":false,"priority":6,"deadlineBackup":-1}],"coreNumber":1,"timeSliceLength":5,"dynamicPriorities":false,"prioChangeComputing":-1,"prioChangeWaiting":2,"lowestPriorityFirst":false,"allKernelLevelThreads":[{"startTime":0,"userID":1005,"kernelThreadName":"P1","kernelthreadID":1,"userStrategy":"FCFS","lowestUserThreadID":-1,"userlevelTimeSliceLength":2,"dynamicPrioritiesKernel":false,"lowestPriorityFirstKernel":false,"prioChangeComputingKernel":-1,"prioChangeWaitingKernel":2,"userSchedulingPreemptive":false},{"startTime":2,"userID":2004,"kernelThreadName":"P2","kernelthreadID":2,"userStrategy":"FCFS","lowestUserThreadID":-1,"userlevelTimeSliceLength":2,"dynamicPrioritiesKernel":false,"lowestPriorityFirstKernel":false,"prioChangeComputingKernel":-1,"prioChangeWaitingKernel":2,"userSchedulingPreemptive":false},{"startTime":0,"userID":3002,"kernelThreadName":"P3","kernelthreadID":3,"userStrategy":"FCFS","lowestUserThreadID":-1,"userlevelTimeSliceLength":2,"dynamicPrioritiesKernel":false,"lowestPriorityFirstKernel":false,"prioChangeComputingKernel":-1,"prioChangeWaitingKernel":2,"userSchedulingPreemptive":false},{"startTime":-1,"userID":-1,"kernelThreadName":"Scheduler","kernelthreadID":-1,"userStrategy":"FCFS","lowestUserThreadID":-1,"userlevelTimeSliceLength":2,"dynamicPrioritiesKernel":false,"lowestPriorityFirstKernel":false,"prioChangeComputingKernel":-1,"prioChangeWaitingKernel":2,"userSchedulingPreemptive":false}],"nextID":4,"highestStartingTime":4,"advancedConfigurationOptions":true,"atLeastOnceCorrected":true,"correctionText":"","showHelpGuides":true}
   */
  @Test
  void Priority_bigtest_multipleEdgecases_1() throws JsonProcessingException {
    // change parameters of the default diagram which should differ from the standard configuration.
    inputDiagram.setDispatcherTime(true);
    // add threads to the diagram
    String obj =
        "[{\"parentid\":1,\"ioAftern\":-1,\"ioLength\":-1,\"deadline\":18,\"cells\":[{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"}],\"startTime\":4,\"computingTime\":9,\"id\":1000,\"priority\":0},{\"parentid\":1,\"ioAftern\":-1,\"ioLength\":-1,\"deadline\":14,\"cells\":[{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"}],\"startTime\":0,\"computingTime\":2,\"id\":1001,\"priority\":4},{\"parentid\":1,\"ioAftern\":-1,\"ioLength\":-1,\"deadline\":21,\"cells\":[{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"}],\"startTime\":3,\"computingTime\":4,\"id\":1002,\"priority\":19},{\"parentid\":1,\"ioAftern\":2,\"ioLength\":2,\"deadline\":25,\"cells\":[{\"status\":\"\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"}],\"startTime\":1,\"computingTime\":5,\"id\":1003,\"priority\":3},{\"parentid\":2,\"ioAftern\":-1,\"ioLength\":-1,\"deadline\":22,\"cells\":[{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"}],\"startTime\":2,\"computingTime\":5,\"id\":2000,\"priority\":0},{\"parentid\":2,\"ioAftern\":-1,\"ioLength\":-1,\"deadline\":33,\"cells\":[{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"}],\"startTime\":2,\"computingTime\":6,\"id\":2001,\"priority\":17},{\"parentid\":2,\"ioAftern\":5,\"ioLength\":2,\"deadline\":36,\"cells\":[{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"}],\"startTime\":3,\"computingTime\":6,\"id\":2002,\"priority\":12},{\"parentid\":2,\"ioAftern\":3,\"ioLength\":4,\"deadline\":20,\"cells\":[{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"}],\"startTime\":6,\"computingTime\":6,\"id\":2003,\"priority\":5},{\"parentid\":3,\"ioAftern\":-1,\"ioLength\":-1,\"deadline\":8,\"cells\":[{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"}],\"startTime\":0,\"computingTime\":2,\"id\":3000,\"priority\":0},{\"parentid\":3,\"ioAftern\":-1,\"ioLength\":-1,\"deadline\":15,\"cells\":[{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"}],\"startTime\":4,\"computingTime\":5,\"id\":3001,\"priority\":5},{\"parentid\":-1,\"ioAftern\":-1,\"ioLength\":-1,\"deadline\":-1,\"cells\":[{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"}],\"startTime\":-1,\"computingTime\":-1,\"id\":-1,\"priority\":6}]"
            + " ";
    assert (testConfiguration(obj));
  }

  /**
   * Configuration:
   * {"strategy":"EDF","schedulerTime":true,"dispatcherTime":true,"userSchedulerTime":true,"preemptive":false,"initialScheduler":false,"allUserLevelThreads":[{"parentid":4,"ioAftern":-1,"ioLength":-1,"deadline":27,"startTime":0,"computingTime":4,"id":4000,"name":"P4_U0","startTimePrevious":0,"deadlinePrevious":27,"IOInterruptionActivated":false,"priority":12,"deadlineBackup":8},{"parentid":4,"ioAftern":-1,"ioLength":-1,"deadline":24,"startTime":3,"computingTime":3,"id":4001,"name":"P4_U1","startTimePrevious":3,"deadlinePrevious":24,"IOInterruptionActivated":false,"priority":1,"deadlineBackup":12},{"parentid":4,"ioAftern":-1,"ioLength":-1,"deadline":15,"startTime":5,"computingTime":4,"id":4002,"name":"P4_U2","startTimePrevious":5,"deadlinePrevious":15,"IOInterruptionActivated":false,"priority":7,"deadlineBackup":15},{"parentid":4,"ioAftern":-1,"ioLength":-1,"deadline":17,"startTime":5,"computingTime":2,"id":4003,"name":"P4_U3","startTimePrevious":5,"deadlinePrevious":17,"IOInterruptionActivated":false,"priority":9,"deadlineBackup":12},{"parentid":5,"ioAftern":-1,"ioLength":-1,"deadline":14,"startTime":5,"computingTime":1,"id":5000,"name":"P5_U0","startTimePrevious":5,"deadlinePrevious":14,"IOInterruptionActivated":false,"priority":18,"deadlineBackup":14},{"parentid":5,"ioAftern":5,"ioLength":3,"deadline":27,"startTime":6,"computingTime":7,"id":5001,"name":"P5_U1","startTimePrevious":6,"deadlinePrevious":27,"IOInterruptionActivated":true,"priority":13,"deadlineBackup":22},{"parentid":5,"ioAftern":1,"ioLength":1,"deadline":30,"startTime":3,"computingTime":6,"id":5002,"name":"P5_U2","startTimePrevious":3,"deadlinePrevious":30,"IOInterruptionActivated":true,"priority":9,"deadlineBackup":16},{"parentid":5,"ioAftern":-1,"ioLength":-1,"deadline":24,"startTime":5,"computingTime":7,"id":5003,"name":"P5_U3","startTimePrevious":5,"deadlinePrevious":24,"IOInterruptionActivated":false,"priority":5,"deadlineBackup":18},{"parentid":6,"ioAftern":-1,"ioLength":-1,"deadline":34,"startTime":7,"computingTime":7,"id":6000,"name":"P6_U0","startTimePrevious":7,"deadlinePrevious":34,"IOInterruptionActivated":false,"priority":4,"deadlineBackup":23},{"parentid":6,"ioAftern":-1,"ioLength":-1,"deadline":25,"startTime":1,"computingTime":6,"id":6001,"name":"P6_U1","startTimePrevious":1,"deadlinePrevious":25,"IOInterruptionActivated":false,"priority":15,"deadlineBackup":10},{"parentid":-1,"ioAftern":-1,"ioLength":-1,"deadline":-1,"startTime":-1,"computingTime":-1,"id":-1,"name":"Scheduler","startTimePrevious":-1,"deadlinePrevious":-1,"IOInterruptionActivated":false,"priority":6,"deadlineBackup":-1}],"coreNumber":1,"timeSliceLength":5,"dynamicPriorities":false,"prioChangeComputing":-1,"prioChangeWaiting":2,"lowestPriorityFirst":false,"allKernelLevelThreads":[{"startTime":0,"userID":4004,"kernelThreadName":"P4","kernelthreadID":4,"userStrategy":"FCFS","lowestUserThreadID":-1,"userlevelTimeSliceLength":2,"dynamicPrioritiesKernel":false,"lowestPriorityFirstKernel":false,"prioChangeComputingKernel":-1,"prioChangeWaitingKernel":2,"userSchedulingPreemptive":false},{"startTime":3,"userID":5004,"kernelThreadName":"P5","kernelthreadID":5,"userStrategy":"FCFS","lowestUserThreadID":-1,"userlevelTimeSliceLength":2,"dynamicPrioritiesKernel":false,"lowestPriorityFirstKernel":false,"prioChangeComputingKernel":-1,"prioChangeWaitingKernel":2,"userSchedulingPreemptive":false},{"startTime":1,"userID":6002,"kernelThreadName":"P6","kernelthreadID":6,"userStrategy":"FCFS","lowestUserThreadID":-1,"userlevelTimeSliceLength":2,"dynamicPrioritiesKernel":false,"lowestPriorityFirstKernel":false,"prioChangeComputingKernel":-1,"prioChangeWaitingKernel":2,"userSchedulingPreemptive":false},{"startTime":-1,"userID":-1,"kernelThreadName":"Scheduler","kernelthreadID":-1,"userStrategy":"FCFS","lowestUserThreadID":-1,"userlevelTimeSliceLength":2,"dynamicPrioritiesKernel":false,"lowestPriorityFirstKernel":false,"prioChangeComputingKernel":-1,"prioChangeWaitingKernel":2,"userSchedulingPreemptive":false}],"nextID":7,"highestStartingTime":7,"advancedConfigurationOptions":true,"atLeastOnceCorrected":true,"correctionText":"","showHelpGuides":true}
   */
  @Test
  void Priority_bigtest_multipleEdgecases_2() throws JsonProcessingException {
    // change parameters of the default diagram which should differ from the standard configuration.
    inputDiagram.setDispatcherTime(true);
    // add threads to the diagram
    String obj =
        "[{\"parentid\":4,\"ioAftern\":-1,\"ioLength\":-1,\"deadline\":27,\"cells\":[{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"}],\"startTime\":0,\"computingTime\":4,\"id\":4000,\"priority\":12},{\"parentid\":4,\"ioAftern\":-1,\"ioLength\":-1,\"deadline\":24,\"cells\":[{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"}],\"startTime\":3,\"computingTime\":3,\"id\":4001,\"priority\":1},{\"parentid\":4,\"ioAftern\":-1,\"ioLength\":-1,\"deadline\":15,\"cells\":[{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"}],\"startTime\":5,\"computingTime\":4,\"id\":4002,\"priority\":7},{\"parentid\":4,\"ioAftern\":-1,\"ioLength\":-1,\"deadline\":17,\"cells\":[{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"}],\"startTime\":5,\"computingTime\":2,\"id\":4003,\"priority\":9},{\"parentid\":5,\"ioAftern\":-1,\"ioLength\":-1,\"deadline\":14,\"cells\":[{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"}],\"startTime\":5,\"computingTime\":1,\"id\":5000,\"priority\":18},{\"parentid\":5,\"ioAftern\":5,\"ioLength\":3,\"deadline\":27,\"cells\":[{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"}],\"startTime\":6,\"computingTime\":7,\"id\":5001,\"priority\":13},{\"parentid\":5,\"ioAftern\":1,\"ioLength\":1,\"deadline\":30,\"cells\":[{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"}],\"startTime\":3,\"computingTime\":6,\"id\":5002,\"priority\":9},{\"parentid\":5,\"ioAftern\":-1,\"ioLength\":-1,\"deadline\":24,\"cells\":[{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"}],\"startTime\":5,\"computingTime\":7,\"id\":5003,\"priority\":5},{\"parentid\":6,\"ioAftern\":-1,\"ioLength\":-1,\"deadline\":34,\"cells\":[{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"}],\"startTime\":7,\"computingTime\":7,\"id\":6000,\"priority\":4},{\"parentid\":6,\"ioAftern\":-1,\"ioLength\":-1,\"deadline\":25,\"cells\":[{\"status\":\"\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"}],\"startTime\":1,\"computingTime\":6,\"id\":6001,\"priority\":15},{\"parentid\":-1,\"ioAftern\":-1,\"ioLength\":-1,\"deadline\":-1,\"cells\":[{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"}],\"startTime\":-1,\"computingTime\":-1,\"id\":-1,\"priority\":6}]"
            + " ";
    assert (testConfiguration(obj));
  }

  /**
   * Configuration:
   * {"strategy":"EDF","schedulerTime":true,"dispatcherTime":true,"userSchedulerTime":true,"preemptive":false,"initialScheduler":false,"allUserLevelThreads":[{"parentid":7,"ioAftern":-1,"ioLength":-1,"deadline":14,"startTime":5,"computingTime":8,"id":7000,"name":"P7_U0","startTimePrevious":5,"deadlinePrevious":14,"IOInterruptionActivated":false,"priority":9,"deadlineBackup":14},{"parentid":7,"ioAftern":-1,"ioLength":-1,"deadline":11,"startTime":0,"computingTime":6,"id":7001,"name":"P7_U1","startTimePrevious":0,"deadlinePrevious":11,"IOInterruptionActivated":false,"priority":18,"deadlineBackup":11},{"parentid":7,"ioAftern":-1,"ioLength":-1,"deadline":31,"startTime":6,"computingTime":6,"id":7002,"name":"P7_U2","startTimePrevious":6,"deadlinePrevious":31,"IOInterruptionActivated":false,"priority":14,"deadlineBackup":16},{"parentid":8,"ioAftern":-1,"ioLength":-1,"deadline":19,"startTime":8,"computingTime":2,"id":8000,"name":"P8_U0","startTimePrevious":8,"deadlinePrevious":19,"IOInterruptionActivated":false,"priority":19,"deadlineBackup":19},{"parentid":8,"ioAftern":2,"ioLength":4,"deadline":27,"startTime":5,"computingTime":3,"id":8001,"name":"P8_U1","startTimePrevious":5,"deadlinePrevious":27,"IOInterruptionActivated":true,"priority":13,"deadlineBackup":11},{"parentid":8,"ioAftern":1,"ioLength":3,"deadline":13,"startTime":3,"computingTime":5,"id":8002,"name":"P8_U2","startTimePrevious":3,"deadlinePrevious":13,"IOInterruptionActivated":true,"priority":14,"deadlineBackup":13},{"parentid":9,"ioAftern":1,"ioLength":2,"deadline":21,"startTime":4,"computingTime":6,"id":9000,"name":"P9_U0","startTimePrevious":4,"deadlinePrevious":21,"IOInterruptionActivated":true,"priority":18,"deadlineBackup":13},{"parentid":9,"ioAftern":3,"ioLength":4,"deadline":21,"startTime":5,"computingTime":5,"id":9001,"name":"P9_U1","startTimePrevious":5,"deadlinePrevious":21,"IOInterruptionActivated":true,"priority":17,"deadlineBackup":12},{"parentid":9,"ioAftern":1,"ioLength":2,"deadline":24,"startTime":5,"computingTime":2,"id":9002,"name":"P9_U2","startTimePrevious":5,"deadlinePrevious":24,"IOInterruptionActivated":true,"priority":19,"deadlineBackup":11},{"parentid":10,"ioAftern":-1,"ioLength":-1,"deadline":17,"startTime":2,"computingTime":1,"id":10000,"name":"P10","startTimePrevious":2,"deadlinePrevious":17,"IOInterruptionActivated":false,"priority":10,"deadlineBackup":11},{"parentid":-1,"ioAftern":-1,"ioLength":-1,"deadline":-1,"startTime":-1,"computingTime":-1,"id":-1,"name":"Scheduler","startTimePrevious":-1,"deadlinePrevious":-1,"IOInterruptionActivated":false,"priority":6,"deadlineBackup":-1}],"coreNumber":1,"timeSliceLength":5,"dynamicPriorities":false,"prioChangeComputing":-1,"prioChangeWaiting":2,"lowestPriorityFirst":false,"allKernelLevelThreads":[{"startTime":0,"userID":7003,"kernelThreadName":"P7","kernelthreadID":7,"userStrategy":"FCFS","lowestUserThreadID":-1,"userlevelTimeSliceLength":2,"dynamicPrioritiesKernel":false,"lowestPriorityFirstKernel":false,"prioChangeComputingKernel":-1,"prioChangeWaitingKernel":2,"userSchedulingPreemptive":false},{"startTime":3,"userID":8003,"kernelThreadName":"P8","kernelthreadID":8,"userStrategy":"FCFS","lowestUserThreadID":-1,"userlevelTimeSliceLength":2,"dynamicPrioritiesKernel":false,"lowestPriorityFirstKernel":false,"prioChangeComputingKernel":-1,"prioChangeWaitingKernel":2,"userSchedulingPreemptive":false},{"startTime":4,"userID":9003,"kernelThreadName":"P9","kernelthreadID":9,"userStrategy":"FCFS","lowestUserThreadID":-1,"userlevelTimeSliceLength":2,"dynamicPrioritiesKernel":false,"lowestPriorityFirstKernel":false,"prioChangeComputingKernel":-1,"prioChangeWaitingKernel":2,"userSchedulingPreemptive":false},{"startTime":2,"userID":10001,"kernelThreadName":"P10","kernelthreadID":10,"userStrategy":"FCFS","lowestUserThreadID":-1,"userlevelTimeSliceLength":2,"dynamicPrioritiesKernel":false,"lowestPriorityFirstKernel":false,"prioChangeComputingKernel":-1,"prioChangeWaitingKernel":2,"userSchedulingPreemptive":false},{"startTime":-1,"userID":-1,"kernelThreadName":"Scheduler","kernelthreadID":-1,"userStrategy":"FCFS","lowestUserThreadID":-1,"userlevelTimeSliceLength":2,"dynamicPrioritiesKernel":false,"lowestPriorityFirstKernel":false,"prioChangeComputingKernel":-1,"prioChangeWaitingKernel":2,"userSchedulingPreemptive":false}],"nextID":11,"highestStartingTime":8,"advancedConfigurationOptions":true,"atLeastOnceCorrected":true,"correctionText":"","showHelpGuides":true}
   */
  @Test
  void Priority_bigtest_multipleEdgecases_3() throws JsonProcessingException {
    // change parameters of the default diagram which should differ from the standard configuration.
    inputDiagram.setDispatcherTime(true);
    // add threads to the diagram
    String obj =
        "[{\"parentid\":7,\"ioAftern\":-1,\"ioLength\":-1,\"deadline\":14,\"cells\":[{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"}],\"startTime\":5,\"computingTime\":8,\"id\":7000,\"priority\":9},{\"parentid\":7,\"ioAftern\":-1,\"ioLength\":-1,\"deadline\":11,\"cells\":[{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"}],\"startTime\":0,\"computingTime\":6,\"id\":7001,\"priority\":18},{\"parentid\":7,\"ioAftern\":-1,\"ioLength\":-1,\"deadline\":31,\"cells\":[{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"}],\"startTime\":6,\"computingTime\":6,\"id\":7002,\"priority\":14},{\"parentid\":8,\"ioAftern\":-1,\"ioLength\":-1,\"deadline\":19,\"cells\":[{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"}],\"startTime\":8,\"computingTime\":2,\"id\":8000,\"priority\":19},{\"parentid\":8,\"ioAftern\":2,\"ioLength\":4,\"deadline\":27,\"cells\":[{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"}],\"startTime\":5,\"computingTime\":3,\"id\":8001,\"priority\":13},{\"parentid\":8,\"ioAftern\":1,\"ioLength\":3,\"deadline\":13,\"cells\":[{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"-\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"}],\"startTime\":3,\"computingTime\":5,\"id\":8002,\"priority\":14},{\"parentid\":9,\"ioAftern\":1,\"ioLength\":2,\"deadline\":21,\"cells\":[{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"}],\"startTime\":4,\"computingTime\":6,\"id\":9000,\"priority\":18},{\"parentid\":9,\"ioAftern\":3,\"ioLength\":4,\"deadline\":21,\"cells\":[{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"}],\"startTime\":5,\"computingTime\":5,\"id\":9001,\"priority\":17},{\"parentid\":9,\"ioAftern\":1,\"ioLength\":2,\"deadline\":24,\"cells\":[{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"}],\"startTime\":5,\"computingTime\":2,\"id\":9002,\"priority\":19},{\"parentid\":10,\"ioAftern\":-1,\"ioLength\":-1,\"deadline\":17,\"cells\":[{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"}],\"startTime\":2,\"computingTime\":1,\"id\":10000,\"priority\":10},{\"parentid\":-1,\"ioAftern\":-1,\"ioLength\":-1,\"deadline\":-1,\"cells\":[{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"}],\"startTime\":-1,\"computingTime\":-1,\"id\":-1,\"priority\":6}]"
            + " ";
    assert (testConfiguration(obj));
  }
}
